# -*- coding: utf-8 -*-
from __future__ import division

from wand.image import Image
from wand.drawing import Drawing
from wand.color import Color
from wand.font import Font

petrol = ["#999b6f", "#3a4e48", "#2f3832"]
red = ["#cb6767", "#9e2828", "#6f1d1b"]
blue = ["#b29cbc", "#6e5c7c", "#41304a"]
slate = ["#bcba9c", "#7c795c", "#3d3b29"]
green = ["#9cbca0", "#5c7c60", "#283e2a"]

black = "#1c110a"
eggshell = "#efe092"
skin = "#c8855f"

bright = 0
mid = 1
dark = 2

lw = 3

def button (name, color_map, width=200, height=40):
    h2 = height//2
    points = [(0,0), (width-h2//2,0), (width,h2), (width-h2//2,height), (0,height), (h2//2,h2)]
    with Image (width=width, height=height) as img:
        with Drawing () as draw:
            draw.fill_color = color_map [mid]
            draw.fill_opacity = 1.0
            draw.stroke_color = black
            draw.stroke_opacity = 1.0
            draw.stroke_width = 0
            draw.polygon (points)
            draw (img)
        img.save (filename="{}_flat.png".format (name))
    points = [(2,2), (width-h2//2,2), (width-2,h2), (width-h2//2,height-2), (2,height-2), (h2//2,h2)]
    with Image (width=width+2*lw, height=height+2*lw) as img:
        with Drawing () as draw:
            draw.fill_color = color_map [mid]
            draw.fill_opacity = 1.0
            draw.stroke_line_cap = "round"
            draw.stroke_line_join = "round"
            draw.stroke_width = lw
            draw.stroke_opacity = 1.0
            draw.stroke_color = color_map [dark]
            draw.polygon (points)
            draw.stroke_color = color_map [bright]
            draw.line (points [0], points [1])
            draw.line (points [1], points [2])
            draw.line (points [4], points [5])
            draw (img)
        img.trim ()
        img.save (filename="{}_normal.png".format (name))
    with Image (width=width+2*lw, height=height+2*lw) as img:
        with Drawing () as draw:
            draw.fill_color = color_map [mid]
            draw.fill_opacity = 1.0
            draw.stroke_line_cap = "round"
            draw.stroke_line_join = "round"
            draw.stroke_width = lw
            draw.stroke_opacity = 1.0
            draw.stroke_color = color_map [dark]
            draw.polygon (points)
            draw.stroke_color = color_map [bright]
            draw.line (points [5], points [0])
            draw.line (points [2], points [3])
            draw.line (points [3], points [4])
            draw (img)
        img.trim ()
        img.save (filename="{}_pressed.png".format (name))

button ("petrol", petrol)
button ("red", red)
button ("blue", blue)
button ("slate", slate)
button ("green", green)
